#include "TKheaders.h"
#include "TK_3GSMAPH5.h"

int main(int argc, char *argv[]){


    /* declare Data struct */
    TKINFO granuleHandle3GSMAPH;

    L3GSMAPH5_GRID  L3GSMAPH;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int nlon, nlat;
    int status;
    float  lat,lon;
 
    /* declare array */
    float  hourlyPrecipRateGC[3600][1800];

    /* HDF file open */
    status = TKopen(inputfile, "3GSMAPH5", TKREAD, "HDF5", job, &granuleHandle3GSMAPH, 1);
    if(status != TK_SUCCESS) {
      fprintf(stderr, "error:file open error[%s] input3GSMAPH\n", inputfile);
    }

    /* Grid data read */
    status = TKreadGrid( &granuleHandle3GSMAPH, &L3GSMAPH);

    /* surfacePrecipitation data read */
    for (nlon=0; nlon<3600; nlon++){
	    for (nlat=0; nlat<1800; nlat++){
	      hourlyPrecipRateGC[nlon][nlat] = L3GSMAPH.hourlyPrecipRateGC[nlon][nlat];
	      if( nlon==1250 && nlat==945 ) {
          lat = (180.0/1800.0) * nlat - 90.0 + (180.0/1800.0/2);
          lon = (360.0/3600.0) * nlon - 180.0 + (360.0/3600.0/2);
          printf("lat=%f, lon=%f\n",lat,lon);
          printf("hourlyPrecipRateGC[%d][%d]= %f (mm/hr)\n",
                                              nlon, nlat, hourlyPrecipRateGC[nlon][nlat]);	
	      }
	    }
    }

    /* HDF File close*/
    status = TKclose(&granuleHandle3GSMAPH);

    return 0;
}

