#include <stdlib.h> 
#include <string.h> 
#include "hdf5.h"

int main(){

    hid_t  file_id, dataset_id;

    /* declare character */
    char inputfile[64]= "../../../data_07A/GPMMRG_MAP_2112010000_H_L3S_MCH_05A.h5";
    char dsetname[64]= "/Grid/hourlyPrecipRateGC";

    /* declare variables */
    int ret;
    float  lat,lon;
 
    /* declare array */
    float hourlyPrecipRateGC[3600][1800];

    /* HDF file open */
    file_id = H5Fopen(inputfile, H5F_ACC_RDONLY, H5P_DEFAULT);
    //printf("H5Fopen=%d \n", file_id); 
    if(file_id < 0 ) {
        fprintf(stderr, "error:File open error[%s] \n", inputfile);
    }
    else{
      /* dataset open */
      dataset_id = H5Dopen(file_id, dsetname, H5P_DEFAULT);
      //printf("H5Dopen=%d \n", dataset_id); 
      if(file_id < 0 ) {
        fprintf(stderr, "error:Dataset open error[%s] \n", inputfile);
      }
      else{
        /* hourlyPrecipRateGC read   */
        ret = H5Dread(dataset_id,H5T_NATIVE_FLOAT,H5S_ALL,H5S_ALL, H5P_DEFAULT, hourlyPrecipRateGC);
        //printf("H5Dread=%d \n", ret); 
        if(ret < 0) {
          fprintf(stderr, "error:Dataset read error[%s]\n", inputfile);
        }   
        else{
          /* file,dataset print */
          printf("file name= %s \n", inputfile);
          printf("data set name= %s \n", dsetname);

          lat = (180.0/1800.0) * 945 - 90.0 + (180.0/1800.0/2);
          lon = (360.0/3600.0) * 1250 - 180.0 + (360.0/3600.0/2);
          printf("lat=%f, lon=%f\n",lat,lon);

          /* hourlyPrecipRateGC print */
          printf("hourlyPrecipRateGC[1250][945]= %f (mm/hr)\n", hourlyPrecipRateGC[1250][945]);
        } 
        /* detaset close   */
        ret = H5Dclose(dataset_id);
      }
      /* HDF file close   */
      ret = H5Fclose(file_id);
    }
    return 0;
}

