#include <stdlib.h> 
#include <string.h> 
#include "hdf5.h"
int main(){

    hid_t  file_id, dataset_id;

    /* declare character */
    char inputfile[64]= "../../../data_07A/GPMCOR_DPR_1806_M_D3M_07X.EORC.h5";
    char dsetname[64]= "/FS/G1/precipRateESurface/mean";

    /* declare variables */
    int ret;
    float  lat,lon;
 
    /* declare array */
    float precipRateESurface[3][3][3][72][28];

    /* HDF file open */
    file_id = H5Fopen(inputfile, H5F_ACC_RDONLY, H5P_DEFAULT);
    //printf("H5Fopen=%d \n", file_id); 
    if(file_id < 0 ) {
        fprintf(stderr, "error:file open error[%s] \n", inputfile);
    }
    else
    { 
        /* dataset open */
        dataset_id = H5Dopen(file_id, dsetname, H5P_DEFAULT);
        //printf("H5Dopen=%d \n", dataset_id);
        if(file_id < 0 ) {
            fprintf(stderr, "error:file open error[%s] \n", inputfile);
        }
        else
        {    
            /* precipRateESurface read   */
            ret = H5Dread(dataset_id,H5T_NATIVE_FLOAT,H5S_ALL,H5S_ALL, H5P_DEFAULT, precipRateESurface);
            //printf("H5Dread=%d \n", ret); 
            if(ret < 0) {
                fprintf(stderr, "error:Dataset read error[%s]\n", inputfile);
            }   
            else
            {
                /* file,dataset print */
                printf("file name= %s \n", inputfile);
                printf("data set name= %s \n", dsetname);

                /* lat/lon print */
                lat = (140.0/28.0) * 14 - 70.0 + (140.0/28.0/2);
                lon = (360.0/72.0) * 63 - 180.0 + (360.0/72.0/2);
                printf("lat=%f, lon=%f\n",lat,lon);

                /* precipRateESurface print */
                printf("precipRateESurface.mean[0][0][0][63][14]= %f \n", precipRateESurface[0][0][0][63][14]);
                printf("precipRateESurface.mean[0][1][0][63][14]= %f \n", precipRateESurface[0][1][0][63][14]);
            } 
            /* detaset close   */
            ret = H5Dclose(dataset_id);
        }
        /* HDF file close   */
        ret = H5Fclose(file_id);
    }
    return 0;
}

