#include "TKheaders.h"
#include "TK_1BPR.h"

int main(int argc, char *argv[]){

  /* declare Data struct */
  TKINFO granuleHandle1BPR;

  L1BPR_FS  L1BPR;

  /* declare character */
  char job[256];
  char inputfile[256];

  strcpy(job, argv[1]);
  strcpy(inputfile, argv[2]);

  /* declare variables */
  int year, month, dayOfMon, hour, min;
  int i, j, k;
  int numOfScan;   
  int status;

  /* declare array */
  float lat[49], lon[49];
  short noisePower[49], echoPower[49][260];

  /* HDF file open */
  status = TKopen(inputfile, "1BPR", TKREAD, "HDF5", job, &granuleHandle1BPR, 1);
  if(status != TK_SUCCESS) {
      fprintf(stderr, "error:file open error[%s] input1BPR\n", inputfile);
  }
  
  /* META data read */
  status = TKgetMetaInt(&granuleHandle1BPR, "SwathHeader",
                          "NumberScansGranule", &numOfScan);
  if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file read error[%s]\n", inputfile);
  }

  /* Scan data read */
  for (i=0; i<numOfScan; i++){
    status = TKreadScan( &granuleHandle1BPR, &L1BPR);

    /* Scantime Read */
    year      = L1BPR.ScanTime.Year;
    month     = L1BPR.ScanTime.Month;
    dayOfMon  = L1BPR.ScanTime.DayOfMonth;
    hour      = L1BPR.ScanTime.Hour;
    min       = L1BPR.ScanTime.Minute;

    for (j=0; j<49; j++){
      /* Latitude and Longitude Read */
      lat[j]  = L1BPR.Latitude[j];
      lon[j]  = L1BPR.Longitude[j];

      /* noisePower Read */
      noisePower[j] = L1BPR.Receiver.noisePower[j];

      /* echoPower Read */
      for (k=0; k<260; k++){
        echoPower[j][k] = L1BPR.Receiver.echoPower[j][k];
      }

      /* Print the value */
      if(i == 946 && j == 19){
        printf("Scan=%d, Angle=%d\n", i, j);
        printf("lat=%f, lon=%f\n", lat[j], lon[j]);
        printf("echoPower[259]= %d \n", echoPower[j][259]);
        printf("noisePower= %d \n", noisePower[j]);
      } 
    }
  }

  /* HDF File close*/
  status = TKclose(&granuleHandle1BPR);

  return 0;
}

