#include "TKheaders.h"
#include "TK_3PR.h"

int main(int argc, char *argv[]){


    /* declare Data struct */
    TKINFO granuleHandle3PR;
    L3PR_FS  L3PR;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int j, k, l, m, n;
    int status;
    float  lat,lon;
 
    /* declare array */
    float  precipESurf[3][3][3][72][28];

    /* HDF file open */
    status = TKopen(inputfile, "3PR", TKREAD, "HDF5", job, &granuleHandle3PR, 1);
    if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file open error[%s] input3PR\n", inputfile);
    }

    /* Grid data read */
    status = TKreadGridMulti( &granuleHandle3PR, &L3PR, "L3PR_FS");

    /* precipRateESurface.mean data read */
    for (j=0; j<3; j++){
	    for (k=0; k<3; k++){
        for (l=0; l<3; l++){
          for (m=0; m<72; m++){
            for (n=0; n<28; n++){
	            precipESurf[j][k][l][m][n] = L3PR.G1.precipRateESurface.mean[j][k][l][m][n];
	            if( m==34 && n==12 && l==0 ){
                lat = (140.0/28.0) * n - 70.0 + (140.0/28.0/2);
                lon = (360.0/72.0) * m - 180.0 + (360.0/72.0/2);
                printf("lat=%f, lon=%f\n",lat,lon);
		            printf("precipRateESurface.mean[%d][%d][%d][%d][%d}= %f (mm/hr)\n",
                                 j, k, l, m, n, precipESurf[j][k][l][m][n]);	
		          }
		        }
		      }
	      }
	    }
    }

    /* HDF File close*/
    status = TKclose(&granuleHandle3PR);

    return 0;
}

