#include "TKheaders.h"
#include "TK_3HSLH.h"

#define LAT 268  /* number of resolution 0.5°grid intervals of latitude from 67°S to 67°N. */  
#define LON 720  /* number of resolution 0.5°grid intervals of longitude from 180°W to 180°E. */
#define LAYER  80  /* number of layer */

int main(int argc, char *argv[]){


    /* declare Data struct */
    TKINFO granuleHandle3HSLH;
    L3HSLH_GRID  L3HSLH;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int i, j, k, l, m, n;
    int status;
    float  lat,lon;
 
    /* declare array */
    float  LHCndMean[80][720][268];

    /* HDF file open */
    status = TKopen(inputfile, "3HSLH", TKREAD, "HDF5", job, &granuleHandle3HSLH, 1);
    if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file open error[%s] input3SLH\n", inputfile);
    }

    /* Grid data read */
    status = TKreadGrid( &granuleHandle3HSLH, &L3HSLH);

    /* LHCndMean read */
    for (j=0; j<LAYER; j++){
	    for (k=0; k<LON; k++){
        for (l=0; l<LAT; l++){
	        LHCndMean[j][k][l] = L3HSLH.LHCndMean[j][k][l];
		      if( j==40 && k==185 && l==220 ){
            lat = (134.0/268.0) * l - 67.0 + (134.0/268.0/2);
            lon = (360.0/720.0) * k - 180.0 + (360.0/720.0/2);
            printf("lat=%f, lon=%f\n",lat,lon);
		        printf("LHCndMean[%d][%d][%d]= %f (K/hr)\n",
                           j, k, l, LHCndMean[j][k][l]);	
	        }
	      }
	    }
    }

    /* HDF File close*/
    status = TKclose(&granuleHandle3HSLH);

    return 0;
}

